using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace CDBurnerXP.IO
{
    public class FormatFileSize
    {
        private static string m_KBName = "KB";
        private static string m_MBName = "MB";
        private static string m_GBName = "GB";

        public static string KBName
        {
            get
            {
                return m_KBName;
            }
            set
            {
                m_KBName = value;
            }
        }

        public static string MBName
        {
            get
            {
                return m_MBName;
            }
            set
            {
                m_MBName = value;
            }
        }

        public static string GBName
        {
            get
            {
                return m_GBName;
            }
            set
            {
                m_GBName = value;
            }
        }

        public static string Format(long length)
        {
            double size = length / 1024d;
            long mbSize = 1048576;
            long gbSize = 1073741824;

            if (length < mbSize)
                return String.Format("{0:0.00} " + KBName, size);

            size /= 1024d;

            if (length < gbSize)
                return string.Format("{0:0.00} " + MBName, size);

            size /= 1024d;

            return string.Format("{0:0.00} " + GBName, size);
        }

        public static string Format(string filePath)
        {
            if (!File.Exists(filePath)) return string.Empty;

            try
            {
                FileInfo info = new FileInfo(filePath);
                return Format(info.Length);
            }
            catch (Exception)
            {
                return string.Empty;
            }
        }
    }
}
