Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
Imports System.ComponentModel
Imports CDBurnerXP.Forms

<ToolboxBitmap(GetType(CDBSizebar))> _
Public Class CDBSizebar
  Inherits System.Windows.Forms.UserControl
  Private Lic As License
#Region " Windows Form Designer generated code "

  Public Sub New()
    MyBase.New()

    'This call is required by the Windows Form Designer.
    InitializeComponent()
    'Lic = LicenseManager.Validate(GetType(CDBSizebar), Me)
    'Add any initialization after the InitializeComponent() call
    'Me.SetStyle(ControlStyles.UserPaint, True)
    'Me.SetStyle(ControlStyles.AllPaintingInWmPaint, True)
    'Me.SetStyle(ControlStyles.DoubleBuffer, True)


  End Sub

  'UserControl1 overrides dispose to clean up the component list.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (Lic Is Nothing) Then
        Lic.Dispose()
        Lic = Nothing
      End If
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  'Required by the Windows Form Designer
  Private components As System.ComponentModel.IContainer

  'NOTE: The following procedure is required by the Windows Form Designer
  'It can be modified using the Windows Form Designer.  
  'Do not modify it using the code editor.
  Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Me.components = New System.ComponentModel.Container
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(CDBSizebar))
    Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
    '
    'ToolTip1
    '
    Me.ToolTip1.Active = False
    Me.ToolTip1.AutomaticDelay = 100
    Me.ToolTip1.AutoPopDelay = 2000
    Me.ToolTip1.InitialDelay = 100
    Me.ToolTip1.ReshowDelay = 20
    '
    'SizeBar3_NET
    '
    Me.AccessibleDescription = resources.GetString("$this.AccessibleDescription")
    Me.AccessibleName = resources.GetString("$this.AccessibleName")
    Me.AutoScroll = CType(resources.GetObject("$this.AutoScroll"), Boolean)
    Me.AutoScrollMargin = CType(resources.GetObject("$this.AutoScrollMargin"), System.Drawing.Size)
    Me.AutoScrollMinSize = CType(resources.GetObject("$this.AutoScrollMinSize"), System.Drawing.Size)
    Me.BackColor = System.Drawing.SystemColors.ControlText
    Me.BackgroundImage = CType(resources.GetObject("$this.BackgroundImage"), System.Drawing.Image)
    Me.Enabled = CType(resources.GetObject("$this.Enabled"), Boolean)
    Me.Font = CType(resources.GetObject("$this.Font"), System.Drawing.Font)
    Me.ImeMode = CType(resources.GetObject("$this.ImeMode"), System.Windows.Forms.ImeMode)
    Me.Location = CType(resources.GetObject("$this.Location"), System.Drawing.Point)
    Me.Name = "SizeBar3_NET"
    Me.RightToLeft = CType(resources.GetObject("$this.RightToLeft"), System.Windows.Forms.RightToLeft)
    Me.Size = CType(resources.GetObject("$this.Size"), System.Drawing.Size)
    Me.ToolTip1.SetToolTip(Me, resources.GetString("$this.ToolTip"))

  End Sub

#End Region
  Event BarValueChange()
  Event OnDiscColorChange()
  Event AddedToDiscColorChange()
  Event OverDiscColorChange()
  Event MaxValueChange()
  Event MinValueChange()
  Public Enum enmDiscType
    DataDisc
    AudioDisc
  End Enum
  Private OnDiscTipSet As Boolean
  Private AddedTipSet As Boolean
  Private OverTipSet As Boolean
  Private varNumTracks As Integer
  Private varDurationArray() As Integer
  Private varTrackLinesColor As Color = Color.Yellow
  Private varTrackIndicatorFont As Font = Me.Font
  Private varTrackIndicatorColor As Color = Color.Yellow
  Private varOverDiscColor As Color = Color.Blue
  Private varAddedToDiscColor As Color = Color.Green
  Private varOnDiscColor As Color = Color.Red
  Private varOverDiscValue As Single = 0
  Private varAddedToDiscValue As Single = 0
  Private varOnDiscValue As Single = 0
  Private varBarvalue As Single = 0
  Private varMinValue As Single = 0
  Private varMaxValue As Single = 100
  Private varValueTextFont As Font = Me.Font
  Private varValueTextFontColor As Color = Me.ForeColor
  Private varUseWarning As Boolean = True
  Private varWarningText As String = "Data exceeds the size of the media"
  Private varUnitText As String = "MB"
  Private varWarningTextFont As Font = Me.Font
  Private varWarningTextFontColor As Color = Me.ForeColor
  Private varBorderStyle As BorderStyle = BorderStyle.Fixed3D
  Private varDiscType As enmDiscType = enmDiscType.DataDisc
  Private varBorderCorr As Integer = 0
  Private varAdditionalWarningText As String = String.Empty

  Public Property TrackIndicatorColor() As Color
    Get
      Return varTrackIndicatorColor
    End Get
    Set(ByVal Value As Color)
      varTrackIndicatorColor = Value
    End Set
  End Property
  Public Property TrackLinesColor() As Color
    Get
      Return varTrackLinesColor
    End Get
    Set(ByVal Value As Color)
      varTrackLinesColor = Value
    End Set
  End Property
  Public Property TrackIndicatorFont() As Font
    Get
      Return varTrackIndicatorFont
    End Get
    Set(ByVal Value As Font)
      varTrackIndicatorFont = Value
    End Set
  End Property
  Public Property DurationArray() As Integer()
    Get
      Return varDurationArray
    End Get
    Set(ByVal Value As Integer())
      If Value Is Nothing Then
        varDurationArray = Nothing
        Exit Property
      End If
      ReDim varDurationArray(Value.Length - 1)
      Array.Copy(Value, varDurationArray, Value.Length)
    End Set
  End Property
  Public Property NumberOfTracks() As Integer
    Get
      Return varNumTracks
    End Get
    Set(ByVal Value As Integer)
      varNumTracks = Value
    End Set
  End Property
  Public Property SizeBarBorderStyle() As BorderStyle
    Get
      SizeBarBorderStyle = varBorderStyle
    End Get
    Set(ByVal Value As BorderStyle)
      varBorderStyle = Value
      Select Case varBorderStyle
        Case BorderStyle.None
          varBorderCorr = 0
        Case BorderStyle.FixedSingle
          varBorderCorr = 1
        Case BorderStyle.Fixed3D
          varBorderCorr = 2
      End Select
      DrawSizebar()
    End Set
  End Property

  Public Property DiscType() As enmDiscType
    Get
      DiscType = varDiscType
    End Get
    Set(ByVal Value As enmDiscType)
      varDiscType = Value
      DrawSizebar()
    End Set
  End Property
  Public Property UseWarning() As Boolean
    Get
      Return varUseWarning
    End Get
    Set(ByVal Value As Boolean)
      varUseWarning = Value
    End Set
  End Property
  Public Property WarningText() As String
    Get
      Return varWarningText
    End Get
    Set(ByVal Value As String)
      varWarningText = Value
    End Set
  End Property

  <Browsable(False)> _
  Public Property AdditionalWarningText() As String
    Get
      Return varAdditionalWarningText
    End Get
    Set(ByVal Value As String)
      varAdditionalWarningText = Value
    End Set
  End Property
  Public Property UnitText() As String
    Get
      Return varUnitText
    End Get
    Set(ByVal Value As String)
      varUnitText = Value
    End Set
  End Property
  Public Property WarningTextFont() As Font
    Get
      WarningTextFont = varWarningTextFont
    End Get
    Set(ByVal Value As Font)
      varWarningTextFont = Value
      DrawSizebar()
    End Set
  End Property
  Public Property WarningTextFontColor() As Color
    Get
      WarningTextFontColor = varWarningTextFontColor
    End Get
    Set(ByVal Value As Color)
      varWarningTextFontColor = Value
      DrawSizebar()
    End Set
  End Property
  Public Property ValueTextFontColor() As Color
    Get
      ValueTextFontColor = varValueTextFontColor
    End Get
    Set(ByVal Value As Color)
      varValueTextFontColor = Value
      DrawSizebar()
    End Set
  End Property
  Public Property ValueTextFont() As Font
    Get
      ValueTextFont = varValueTextFont
    End Get
    Set(ByVal Value As Font)
      varValueTextFont = Value
      DrawSizebar()
    End Set
  End Property
  Public Property OnDiscValue() As Single
    Get
      OnDiscValue = varOnDiscValue
    End Get
    Set(ByVal Value As Single)
      varOnDiscValue = Value
    End Set
  End Property
  'Public Property AddedToDiscValue() As Double
  '    Get
  '        AddedToDiscValue = varAddedToDiscValue
  '    End Get
  '    Set(ByVal Value As Double)
  '        varAddedToDiscValue = Value
  '    End Set
  'End Property
  Public Property OverDiscValue() As Single
    Get
      OverDiscValue = varOverDiscValue
    End Get
    Set(ByVal Value As Single)
      varOverDiscValue = Value
    End Set
  End Property
  Public Property MaxValue() As Single
    Get
      MaxValue = varMaxValue
    End Get
    Set(ByVal Value As Single)
      varMaxValue = Value
      'RaiseEvent MaxValueChange()
    End Set
  End Property
  Public Property MinValue() As Single
    Get
      MinValue = varMinValue
    End Get
    Set(ByVal Value As Single)
      varMinValue = Value
      'RaiseEvent MinValueChange()
    End Set
  End Property
  Public Property BarValue() As Single
    Get
      BarValue = varBarvalue
    End Get
    Set(ByVal Value As Single)
      varBarvalue = Value
      'RaiseEvent BarValueChange()
    End Set
  End Property
  Public Property OnDiscColor() As Color
    Get
      OnDiscColor = varOnDiscColor
    End Get
    Set(ByVal Value As Color)
      varOnDiscColor = Value
      'DrawSizebar()
      'RaiseEvent OnDiscColorChange()
    End Set
  End Property
  Public Property AddedToDiscColor() As Color
    Get
      AddedToDiscColor = varAddedToDiscColor
    End Get
    Set(ByVal Value As Color)
      varAddedToDiscColor = Value
      DrawSizebar()
      'RaiseEvent AddedToDiscColorChange()
    End Set
  End Property
  Public Property OverDiscColor() As Color
    Get
      OverDiscColor = varOverDiscColor
    End Get
    Set(ByVal Value As Color)
      varOverDiscColor = Value
      DrawSizebar()
      ' RaiseEvent OverDiscColorChange()
    End Set
  End Property

  Private Sub DrawSizebar()
    'Dim gr As Graphics = Me.CreateGraphics()
    If Me.DisplayRectangle.Width < 1 Or Me.DisplayRectangle.Height < 1 Then Exit Sub
    Dim g As New DBLBuffering(Me.DisplayRectangle.Width, Me.DisplayRectangle.Height)
    Dim gr As Graphics = g.Store
    'Dim bordercorr As Integer

    Dim brText As SolidBrush = New SolidBrush(varValueTextFontColor)
    Dim brText2 As SolidBrush = New SolidBrush(varWarningTextFontColor)
    Dim penMaxLine As Pen = New Pen(varOverDiscColor, 1)
    Dim CanvasCorrWidth As Single = g.Canvas.Width - varBorderCorr
    Dim CanvasCorrHeight As Single = g.Canvas.Height - varBorderCorr
    gr.TextRenderingHint = TextRenderingHint.AntiAlias
    gr.CompositingMode = CompositingMode.SourceOver
    gr.Clear(Me.BackColor)
    'Note:On Disc Bar

    If varOnDiscValue > 0 Then
      Dim brTop As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, 0, 1, CanvasCorrHeight * 0.4), Me.BackColor, varOnDiscColor, LinearGradientMode.Vertical)
      Dim brBottom As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.5, 1, CanvasCorrHeight), varOnDiscColor, Me.BackColor, LinearGradientMode.Vertical)
      Dim brMid As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.4, 1, CanvasCorrHeight * 0.6), varOnDiscColor, varOnDiscColor, LinearGradientMode.Vertical)
      gr.FillRectangle(brTop, 0, 0, CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.4))
      gr.FillRectangle(brMid, 0, CSng(CanvasCorrHeight * 0.4), CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.6))
      gr.FillRectangle(brBottom, 0, CSng(CanvasCorrHeight * 0.6), CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight))
      brTop.Dispose()
      brBottom.Dispose()
      brMid.Dispose()
    End If
    'Note:Added to Disc Bar
    If varBarvalue > 0 Then
      If varBarvalue + varOnDiscValue <= varOverDiscValue Then
        varAddedToDiscValue = varBarvalue + varOnDiscValue
      Else
        varAddedToDiscValue = varOverDiscValue
      End If
      Dim brTop As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, 0, 1, CanvasCorrHeight * 0.4), Me.BackColor, varAddedToDiscColor, LinearGradientMode.Vertical)
      Dim brBottom As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.6, 1, CanvasCorrHeight), varAddedToDiscColor, Me.BackColor, LinearGradientMode.Vertical)
      Dim brMid As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.4, 1, CanvasCorrHeight * 0.6), varAddedToDiscColor, varAddedToDiscColor, LinearGradientMode.Vertical)
      gr.FillRectangle(brTop, CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), 0, CanvasCorrWidth * (varAddedToDiscValue - varOnDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.4))
      gr.FillRectangle(brMid, CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.4), CanvasCorrWidth * (varAddedToDiscValue - varOnDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.6))
      gr.FillRectangle(brBottom, CanvasCorrWidth * varOnDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.6), CanvasCorrWidth * (varAddedToDiscValue - varOnDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight))
      brTop.Dispose()
      brBottom.Dispose()
      brMid.Dispose()
    End If
    'Note:Over Disc Bar
    If varBarvalue + varOnDiscValue > varOverDiscValue Then
      Dim brTop As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, 0, 1, CanvasCorrHeight * 0.4), Me.BackColor, varOverDiscColor, LinearGradientMode.Vertical)
      Dim brBottom As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.6, 1, CanvasCorrHeight), varOverDiscColor, Me.BackColor, LinearGradientMode.Vertical)
      Dim brMid As LinearGradientBrush = New LinearGradientBrush(New RectangleF(0, CanvasCorrHeight * 0.4, 1, CanvasCorrHeight * 0.6), varOverDiscColor, varOverDiscColor, LinearGradientMode.Vertical)
      gr.FillRectangle(brTop, CanvasCorrWidth * varOverDiscValue / (varMaxValue - varMinValue), 0, CanvasCorrWidth * (varBarvalue + varOnDiscValue - varOverDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.4))
      gr.FillRectangle(brMid, CanvasCorrWidth * varOverDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.4), CanvasCorrWidth * (varBarvalue + varOnDiscValue - varOverDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.6))
      gr.FillRectangle(brBottom, CanvasCorrWidth * varOverDiscValue / (varMaxValue - varMinValue), CSng(CanvasCorrHeight * 0.6), CanvasCorrWidth * (varBarvalue + varOnDiscValue - varOverDiscValue) / (varMaxValue - varMinValue), CSng(CanvasCorrHeight))
      brTop.Dispose()
      brBottom.Dispose()
      brMid.Dispose()
    End If
    'Note: Line at CD MAX
    gr.DrawLine(penMaxLine, CInt(CanvasCorrWidth * varOverDiscValue / (varMaxValue - varMinValue)), 0, CInt(CanvasCorrWidth * varOverDiscValue / (varMaxValue - varMinValue)), CanvasCorrHeight)
    penMaxLine.Dispose()
    'Note: Text for value etc.
    Dim strValueString As String
    If varDiscType = enmDiscType.DataDisc Then
      strValueString = (varOnDiscValue + varBarvalue).ToString("0.00") & " " & UnitText
    Else
      Dim tmpDate As Date
      Dim secondadd As Single = varOnDiscValue + varBarvalue
      If secondadd > 0 Then
        tmpDate = tmpDate.AddSeconds(secondadd)
        strValueString = BaseForm.FormatTranslation("{0:00}:{1:00} minutes", tmpDate.Hour * 60 + tmpDate.Minute, tmpDate.Second)
      Else
        strValueString = BaseForm.FormatTranslation("{0:00}:{1:00} minutes", 0, 0)
      End If
      tmpDate = tmpDate.AddSeconds(-secondadd)

      ' = tmpDate.ToLongTimeString.ToString
    End If
    Dim ValueStringPos As Integer = 0
    If CInt(CanvasCorrWidth * (varOnDiscValue + varBarvalue) / (varMaxValue - varMinValue)) - strValueString.Length * varValueTextFont.SizeInPoints < 0 Then
      gr.DrawString(strValueString, varValueTextFont, brText, 3, (CanvasCorrHeight - varValueTextFont.Size) / 2)

    ElseIf CInt(CanvasCorrWidth * (varOnDiscValue + varBarvalue) / (varMaxValue - varMinValue)) > CanvasCorrWidth Then
      ValueStringPos = CInt(CanvasCorrWidth - strValueString.Length * varValueTextFont.SizeInPoints)
      gr.DrawString(strValueString, varValueTextFont, brText, ValueStringPos, (CanvasCorrHeight - varValueTextFont.Size) / 2)
    Else
      ValueStringPos = CInt(CanvasCorrWidth * (varOnDiscValue + varBarvalue) / (varMaxValue - varMinValue)) - strValueString.Length * varValueTextFont.SizeInPoints - 2
      gr.DrawString(strValueString, varValueTextFont, brText, ValueStringPos, (CanvasCorrHeight - varValueTextFont.Size) / 2)
    End If
    'Dim strWarning As String = "Data exceeds the size of the media"
    If varUseWarning Then
      Dim fullWarningText As String = AdditionalWarningText

      If varBarvalue + varOnDiscValue > varOverDiscValue Then
        fullWarningText += If(String.IsNullOrEmpty(fullWarningText), WarningText, "; " + WarningText)
      End If

      If Not String.IsNullOrEmpty(fullWarningText) Then
        If ValueStringPos <= fullWarningText.Length * varWarningTextFont.SizeInPoints Then
          gr.DrawString(fullWarningText, varWarningTextFont, brText2, ValueStringPos + strValueString.Length * varValueTextFont.SizeInPoints + 10, CanvasCorrHeight - varWarningTextFont.SizeInPoints * 2)
        Else
          gr.DrawString(fullWarningText, varWarningTextFont, brText2, 3, CanvasCorrHeight - varWarningTextFont.SizeInPoints * 2)
        End If
      End If
    End If
    If Not varDurationArray Is Nothing Then
      If varDurationArray.Length > 0 Then
        If varDiscType = enmDiscType.AudioDisc And (Not varDurationArray.Length = 0) Then
          'add trackmarkers
          Dim TrackPen As New Pen(Color.FromArgb(180, varTrackLinesColor), 0.5)
          TrackPen.DashStyle = DashStyle.Dot
          Dim brTrackNum As New SolidBrush(Color.FromArgb(180, varTrackIndicatorColor))
          Dim nextTime As Single = 0
          Dim k As Integer = 0
          Dim lasttime As Single = 0
          For Each duration As Integer In varDurationArray
            Dim durationInSeconds As Single = duration / 1000.0
            nextTime = nextTime + durationInSeconds + 2
            If k = varDurationArray.Length - 1 Then
              nextTime -= 2 'No gap on last track
            End If

            gr.DrawLine(TrackPen, CanvasCorrWidth * (nextTime + varOnDiscValue) / (varMaxValue - varMinValue), 0, CanvasCorrWidth * (nextTime + varOnDiscValue) / (varMaxValue - varMinValue), CanvasCorrHeight)
            Dim strtrackindicator As String = "#" & k + 1
            If (CanvasCorrWidth * (nextTime - lasttime) / (varMaxValue - varMinValue)) > gr.MeasureString(strtrackindicator, varTrackIndicatorFont).Width Then
              gr.DrawString(strtrackindicator, varTrackIndicatorFont, brTrackNum, CanvasCorrWidth * (nextTime + varOnDiscValue - (nextTime - lasttime) / 2 - gr.MeasureString(strtrackindicator, varTrackIndicatorFont).Width / 2) / (varMaxValue - varMinValue), 2)
            End If
            k += 1
            lasttime = nextTime
          Next
          TrackPen.Dispose()
          brTrackNum.Dispose()
        End If
      End If
    End If

    DrawBorder(gr, Me.DisplayRectangle, varBorderStyle)
    g.Paint(Me)
    g.Dispose()
    'gr.Dispose()
    brText.Dispose()
    brText2.Dispose()
  End Sub
  Private Sub DrawBorder(ByRef gr As Graphics, ByVal rect As Rectangle, ByVal border_style As BorderStyle, Optional ByVal sunken As Boolean = True)
    Select Case border_style
      Case BorderStyle.FixedSingle
        rect.Width -= 1
        rect.Height -= 1
        gr.DrawRectangle(Pens.Black, rect)
      Case BorderStyle.Fixed3D
        Dim colors() As Color
        If sunken Then
          colors = New Color() { _
              SystemColors.ControlDark, _
              SystemColors.ControlDarkDark, _
              SystemColors.ControlLightLight, _
              SystemColors.ControlLight _
          }
        Else
          colors = New Color() { _
              SystemColors.ControlLightLight, _
              SystemColors.ControlLight, _
              SystemColors.ControlDark, _
              SystemColors.ControlDarkDark _
          }
        End If
        Dim p1 As Pen = New Pen(colors(0))
        gr.DrawLine(p1, rect.X, rect.Y + rect.Height - 1, rect.X, rect.Y)
        gr.DrawLine(p1, rect.X, rect.Y, rect.X + rect.Width - 1, rect.Y)
        p1.Dispose()
        Dim p2 As Pen = New Pen(colors(1))
        gr.DrawLine(p2, rect.X + 1, rect.Y + rect.Height - 2, rect.X + 1, rect.Y + 1)
        gr.DrawLine(p2, rect.X + 1, rect.Y + 1, rect.X + rect.Width - 2, rect.Y + 1)
        p2.Dispose()
        Dim p3 As Pen = New Pen(colors(2))
        gr.DrawLine(p3, rect.X, rect.Y + rect.Height - 1, rect.X + rect.Width - 1, rect.Y + rect.Height - 1)
        gr.DrawLine(p3, rect.X + rect.Width - 1, rect.Y + rect.Height - 1, rect.X + rect.Width - 1, rect.Y)
        p3.Dispose()
        Dim p4 As Pen = New Pen(colors(3))
        gr.DrawLine(p4, rect.X + 1, rect.Y + rect.Height - 2, rect.X + rect.Width - 2, rect.Y + rect.Height - 2)
        gr.DrawLine(p4, rect.X + rect.Width - 2, rect.Y + rect.Height - 2, rect.X + rect.Width - 2, rect.Y + 1)
        p4.Dispose()
    End Select
  End Sub
  Public Sub UpdateSizeBar()
    DrawSizebar()
  End Sub


  Private Sub SizeBar3_NET_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'varMinValue = 0
    'varMaxValue = 100
    DrawSizebar()
  End Sub

  Private Sub SizeBar3_NET_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize

    DrawSizebar()
  End Sub

  Private Sub SizeBar3_NET_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
    DrawSizebar()
  End Sub

End Class
