Imports System.ComponentModel

Public Class DeviceAndSpeedSelect
  Inherits CDBurnerXP.Controls.SpeedSelect

  Public Event SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)

  Private WithEvents m_DriveSelect As New DeviceSelect()

  Public Overloads Property Enabled() As Boolean
    Get
      Return MyBase.Enabled
    End Get
    Set(ByVal value As Boolean)
      MyBase.Enabled = value
      DeviceSelect.Enabled = value
    End Set
  End Property

  <CLSCompliant(False), Browsable(False)> _
  Public ReadOnly Property DeviceSelect() As DeviceSelect
    Get
      Return m_DriveSelect
    End Get
  End Property

  <DefaultValue(False)> _
  Public Property UseStarBurn() As Boolean
    Get
      Return DeviceSelect.UseStarBurn
    End Get
    Set(ByVal value As Boolean)
      DeviceSelect.UseStarBurn = value
    End Set
  End Property

  Public Property ShowText() As Boolean
    Get
      Return lblBurnSpeed.Visible
    End Get
    Set(ByVal value As Boolean)
      lblBurnSpeed.Visible = value
    End Set
  End Property

  Sub New()
    ' This call is required by the Windows Form Designer.
    InitializeComponent()

    Me.tblLayout.ColumnCount += 1
    Me.tblLayout.ColumnStyles.Insert(1, (New ColumnStyle(SizeType.Percent, 100)))
    Me.tblLayout.Controls.Add(m_DriveSelect, 1, 0)
    m_DriveSelect.TabIndex = 0
    cboBurnSpeed.TabIndex = 1
    m_DriveSelect.Anchor = (AnchorStyles.Bottom Or AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Right)
  End Sub

  Private Sub OnLoaded(ByVal sender As Object, ByVal e As EventArgs) Handles m_DriveSelect.VisibleChanged
    If m_DriveSelect.SelectedDeviceLetter IsNot Nothing And Me.BurnSpeedDeviceLetter Is Nothing Then
      Me.BurnSpeedDeviceLetter = m_DriveSelect.SelectedDeviceLetter
    End If
  End Sub

  Private Sub OnDeviceChanged(ByVal sender As Object, ByVal e As EventArgs) Handles m_DriveSelect.SelectedIndexChanged
    cboBurnSpeed.Enabled = (m_DriveSelect.SelectedDeviceLetter IsNot Nothing)

    If m_DriveSelect.SelectedDeviceLetter IsNot Nothing Then
      Me.BurnSpeedDeviceLetter = m_DriveSelect.SelectedDeviceLetter
    End If

    RaiseEvent SelectedIndexChanged(Me, Nothing)
  End Sub


  Protected Overrides Sub Finalize()
    m_DriveSelect.Dispose()
    MyBase.Finalize()
  End Sub

End Class
