'*************************************************************************
' Klass: frmFilter
' Beroenden: 
' Syfte: 
' F�rfattare: Fredrik Haglund, Stefan Haglund
' Senast �ndrad av: Stefan Haglund
' Senast �ndrad: 2007-04-26 08:27
' Kommentarer: 
'*************************************************************************

Imports System.Threading
Imports System.Globalization
Imports System.Resources
Imports CDBurnerXP

Public Class frmFilter
  Private _isData As Boolean = False

  Protected Overrides ReadOnly Property AutoTranslate() As Boolean
    Get
      Return True
    End Get
  End Property

  Public Sub New(ByVal isData As Boolean)
    ' This call is required by the Windows Form Designer.
    InitializeComponent()
    _isData = isData
    AcceptButton = cmdOK
    CancelButton = cmdCancel

  End Sub

  Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
    MyBase.OnLoad(e)

    'Language Set
    txtFilter.Bounds = New Rectangle(lblFilePattern.Right + 3, txtFilter.Top, Me.Width - 19 - lblFilePattern.Right - 3, txtFilter.Height)
    lblInfo.Left = txtFilter.Left
    Dim strInfo As String = RM.GetString("For more than one file type, use ';' as separator.")
    Dim strExample As String = RM.GetString("Example: *.exe;*.jpg;*.bmp")
    lblInfo.Text = strInfo & Environment.NewLine & strExample

    If _isData Then
      txtFilter.Text = ApplicationSettings.DataFilePattern
      rbInclude.Checked = ApplicationSettings.DataFilePatternInclude
      chkShowFiles.Checked = ApplicationSettings.DataFilePatternShowInBrowser
    Else
      txtFilter.Text = ApplicationSettings.AudioFilePattern
      rbInclude.Checked = ApplicationSettings.AudioFilePatternInclude
      chkShowFiles.Checked = ApplicationSettings.AudioFilePatternShowInBrowser
    End If

    rbExclude.Checked = Not rbInclude.Checked
  End Sub

  Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK.Click
    If _isData Then
      ApplicationSettings.DataFilePattern = txtFilter.Text
      ApplicationSettings.DataFilePatternInclude = rbInclude.Checked
      ApplicationSettings.DataFilePatternShowInBrowser = chkShowFiles.Checked
    Else
      ApplicationSettings.AudioFilePattern = txtFilter.Text
      ApplicationSettings.AudioFilePatternInclude = rbInclude.Checked
      ApplicationSettings.AudioFilePatternShowInBrowser = chkShowFiles.Checked
    End If
    Me.Close()
  End Sub

End Class
