﻿using System;
using System.Collections.Generic;
using System.Text;
using LogicNP.FolderViewControl;
using CDBurnerXP.Forms;
using System.Windows.Forms;

namespace CDBurnerXP.Controls
{
    public class RtlFolderView : FolderView, IMirrorControl
    {
        protected override void OnHandleCreated(EventArgs e)
        {
            base.OnHandleCreated(e);

            // See http://www.ssware.com/megapack/dynamic_licensing_net.htm
            string prefix = @"\\192.168.1.1\IntraNet\";
            this.SelectNode(prefix + "Nv?>ADXpb2HmYV2dU1LlbVj-ehnAYV3rZWXiclHiIDvmbVj-ZVOnaV3jb/@gYV3rZWXiclHiLlLsbPB-22?OIu_cCLpSIsvDoYuki2J_4nF?UWH,+Xmsej4gfkx2Z5_arnu_x5)Ghj76M2m", false, false);
        }

        #region IMirrorControl Member

        public bool Mirror { get; set; }

        protected override CreateParams CreateParams
        {
            get
            {
                if (this.Mirror || BaseForm.IsRightToLeftCulture)
                {
                    try
                    {
                        this.RightToLeftLayout = true;
                    }
                    catch (Exception)
                    {
                        // New property, older versions of the same DLL (if installed in GAC) may not have it.
                    }

                    CreateParams mirroredCp = base.CreateParams;
                    mirroredCp.ExStyle = mirroredCp.ExStyle | 0x400000;
                    return mirroredCp;
                }

                return base.CreateParams;
            }
        }

        #endregion
    }
}
