﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Microsoft.Win32;

namespace CDBurnerXP.Drawing
{
    /// <summary>
    /// Provides helping methods for RTL layouts.
    /// </summary>
    public static class RtlHelper
    {
        public static Icon FlipIfNecessary(Icon original, bool needsRtl)
        {
            if (needsRtl)
            {
                Bitmap bitmap = original.ToBitmap();
                bitmap.RotateFlip(RotateFlipType.RotateNoneFlipX);
                IntPtr icon = bitmap.GetHicon();
                try
                {
                    return Icon.FromHandle(icon).Clone() as Icon;
                }
                finally
                {
                    User32.DestroyIcon(icon);
                }
            }

            return original;
        }

        public static Image FlipIfNecessary(Image image, bool needsRtl)
        {
            if (needsRtl)
            {
                image.RotateFlip(RotateFlipType.RotateNoneFlipX);
            }

            return image;
        }
    }
}
