﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using CDBurnerXP.Forms;
using CDBurnerXP.Controls;

namespace CDBurnerXP.Forms
{
    public partial class FileReportBase : BaseForm
    {
        #region Properties

        protected override bool AutoTranslate
        {
            get
            {
                return true;
            }
        }

        #endregion

        public FileReportBase()
        {
            InitializeComponent();
            CancelButton = bClose;
        }

        protected override void OnLoad(EventArgs e)
        {
            if (DesignMode) return;
            
            m_ExportToFile.FileName = RM.GetString("Error");
            m_ExportToFile.Title = RM.GetString("Export Error Log");
            m_ExportToFile.Filter = RM.GetString("Text files") + "|*.txt";

            // Set images at runtime (transparency)
            ilIcons.Images.Add(CsLib.Properties.Resources.Document);
            ilIcons.Images.Add(CsLib.Properties.Resources.FolderError);
            ilIcons.Images.Add(CsLib.Properties.Resources.DocumentError);
            ilIcons.Images.Add(CsLib.Properties.Resources.Folder);

            base.OnLoad(e);
        }

        private void bExport_Click(object sender, EventArgs e)
        {
            if (m_ExportToFile.ShowDialog() == DialogResult.OK)
            {
                StringBuilder sbText = new StringBuilder();

                for (int i = 0; i < olvErrors.Items.Count; i++)
                {
                    OLVListItem row = olvErrors.GetItem(i);
                    for (int j = 0; j < row.SubItems.Count; j++)
                    {
                        if (j > 0)
                        {
                            sbText.Append("\t");
                        }
                        sbText.Append(row.SubItems[j].Text);
                    }
                    sbText.AppendLine();
                }

                try
                {
                    File.WriteAllText(m_ExportToFile.FileName, sbText.ToString());
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, RM.GetString("Error"), MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
