#!/bin/sh

# This script checks if there is a new english base translation available, provides a diff
# file and also sends out a notification.
#set +e

cd  /srv/www/vhosts/flyspray.org/subdomains/scm/cdbxpAuto/LanguageFetch
REVS="/srv/www/vhosts/flyspray.org/subdomains/scm/repos/cdburnerxp/db/revs"
TARGET="/srv/www/vhosts/cdburnerxp.se/htdocs/downloads/lang_files/source"
RESX="http://scm.flyspray.org/repos/cdburnerxp/trunk/CDBurnerXP/Resources/Strings.resx"
IFS="
"

echo "Checking revisions..."

#Get all revisions of Strings.resx

for i in `svn log -q --username reader --password cdbxpsvn_reader $RESX |  sed 's/r\([0-9]*\).*/\1/' | grep '^[0-9]\+$'`
do
    echo $i
    # If new (not exists) send mail!
    if [ ! -e "$TARGET/$i" ]
	then
	echo "...new"
	mkdir -p "$TARGET/$i"
  TMPFILE=`mktemp` || exit 1
	svn diff --username reader --password cdbxpsvn_reader -r `expr $i - 1`:$i $RESX > "$TMPFILE" && mv "$TMPFILE" "$TARGET/$i/changes.diff"
	chmod 644 "$TARGET/$i/changes.diff"
	svn export --force --username reader --password cdbxpsvn_reader -r $i $RESX "$TARGET/$i/Strings.resx"

	echo -e "A new language file version is available (r$i)!\nDownload at http://cdburnerxp.se/downloads/lang_files/source/$i/Strings.resx\nChanges: http://cdburnerxp.se/downloads/lang_files/source/$i/changes.diff" | mailx -s "New language file" -r "langfile@scm.flyspray.org" "cdburnerxp-devel@googlegroups.com"
	
	# Update SQL database (set lang file version += 0.1
	echo "USE cdburnerxpse; UPDATE trans_lang SET comment = comment + 0.1 WHERE lang_name = 'Original (english)' ORDER BY comment DESC LIMIT 1;" | mysql -u cdburner --password="232977_sff"
    fi
done

# Make latest file public at a specific location
svn export --force --username reader --password cdbxpsvn_reader $RESX "/srv/www/vhosts/cdburnerxp.se/htdocs/downloads/lang_files/Strings.resx"
